From: Carlos Garnacho <carlosg@gnome.org>
Date: Wed, 27 Jan 2021 16:55:10 +0100
Subject: fileItem: Ignore double click distance clicking on items

Imitate the behavior of Nautilus canvas WRT double clicks being
handled on all of the icon(s) without accounting for the double
click distance. As the extension does already lean on Nautilus
look & feel, it seems to make sense doing this.

This is not as crucial for mice as it is for touchscreens, where
the default 5px limit may be a bit on the short side depending
on device sensitivity.
---
 fileItem.js | 26 +++++++++++++++++++++++---
 1 file changed, 23 insertions(+), 3 deletions(-)

diff --git a/fileItem.js b/fileItem.js
index 832599d..1bcb23f 100644
--- a/fileItem.js
+++ b/fileItem.js
@@ -75,6 +75,9 @@ var FileItem = GObject.registerClass({
         this._setMetadataCancellable = null;
         this._queryFileInfoCancellable = null;
         this._isSpecial = this._fileExtra != Prefs.FileType.NONE;
+        this._lastClickTime = 0;
+        this._lastClickButton = 0;
+        this._clickCount = 0;
 
         this._file = file;
         this._mount = null;
@@ -739,7 +742,24 @@ var FileItem = GObject.registerClass({
         DesktopIconsUtil.launchTerminal(this.file.get_path());
     }
 
+    _updateClickState(event) {
+        let settings = Clutter.Settings.get_default();
+        if ((event.get_button() == this._lastClickButton) &&
+            ((event.get_time() - this._lastClickTime) < settings.double_click_time))
+            this._clickCount++;
+        else
+            this._clickCount = 1;
+
+        this._lastClickTime = event.get_time();
+        this._lastClickButton = event.get_button();
+    }
+
+    _getClickCount() {
+        return this._clickCount;
+    }
+
     _onPressButton(actor, event) {
+        this._updateClickState(event);
         let button = event.get_button();
         if (button == 3) {
             if (!this.isSelected)
@@ -758,7 +778,7 @@ var FileItem = GObject.registerClass({
                 this._actionTrash.setSensitive(!specialFilesSelected);
             return Clutter.EVENT_STOP;
         } else if (button == 1) {
-            if (event.get_click_count() == 1) {
+            if (this._getClickCount() == 1) {
                 let [x, y] = event.get_coords();
                 this._primaryButtonPressed = true;
                 this._buttonPressInitialX = x;
@@ -817,11 +837,11 @@ var FileItem = GObject.registerClass({
                 this._primaryButtonPressed = false;
                 let shiftPressed = !!(event.get_state() & Clutter.ModifierType.SHIFT_MASK);
                 let controlPressed = !!(event.get_state() & Clutter.ModifierType.CONTROL_MASK);
-                if ((event.get_click_count() == 1) && Prefs.CLICK_POLICY_SINGLE && !shiftPressed && !controlPressed)
+                if ((this._getClickCount() == 1) && Prefs.CLICK_POLICY_SINGLE && !shiftPressed && !controlPressed)
                     this.doOpen();
                 return Clutter.EVENT_STOP;
             }
-            if ((event.get_click_count() == 2) && (!Prefs.CLICK_POLICY_SINGLE))
+            if ((this._getClickCount() == 2) && (!Prefs.CLICK_POLICY_SINGLE))
                 this.doOpen();
         }
         return Clutter.EVENT_PROPAGATE;
